/**************************************************************************/
/*                                                                        */
/*  This file is part of FISSC.                                           */
/*                                                                        */
/*  you can redistribute it and/or modify it under the terms of the GNU   */
/*  Lesser General Public License as published by the Free Software       */
/*  Foundation, version 3.0.                                              */
/*                                                                        */
/*  It is distributed in the hope that it will be useful,                 */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*  GNU Lesser General Public License for more details.                   */
/*                                                                        */
/*  See the GNU Lesser General Public License version 3.0                 */
/*  for more details (enclosed in the file LICENSE).                      */
/*                                                                        */
/**************************************************************************/

#include "types.h"
#include "interface.h"


UBYTE g_countermeasure;
int g_M;
int g_N;
int g_e;
int g_p;
int g_q;
int g_dp;
int g_dq;
int g_iq;
int g_sign;
int g_true_sign;
int Add(int, int);
int Sub(int, int);
int Mul(int, int);
int Mod(int, int);
int MulMod(int, int, int);
int PowerMod(int, int, int);

int RsaSign2() {
  int Cp3, Cq3, tmp3;
  Cp3 = PowerMod(g_M, g_dp, g_p);
  Cq3 = PowerMod(g_M, g_dq, g_q);
  tmp3 = Sub(Cp3, Cq3);
  tmp3 = MulMod(tmp3, g_iq, g_p);
  tmp3 = Mul(tmp3, g_q);
  tmp3 = Add(tmp3, Cq3);
  g_sign = tmp3;
  return g_sign;
}

void initialize() {
  g_countermeasure = 0;
  g_N = 11413;
  g_e = 3533;
  g_p = 101;
  g_q = 113;
  g_iq = 59;  /* iq = (1/q) mod p */
  g_dp = 6597;  /* dp = d, must be recomputed in CRT function ! */
  g_dq = 6597;  /* dq = d, must be recomputed in CRT function ! */
  g_sign = -1;
  g_M = 23;
  g_true_sign=RsaSign2();
}
